module ActiveState
  class StateValidator < ActiveModel::Validator
    def validate(record)
      state = record.state
      unless state.respond_to? :valid?
        raise NoMethodError, "State object #{state.inspect} does not respond to :valid?"
      end

      return if state.valid?

      state.errors.each do |attribute, message|
        record.errors.add attribute, message
      end
    end
  end
end
